// CMainDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NikyComProgPic16F873A.h"
#include "CMainDlg.h"
#include "NikyTimer1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

struct TPicMemRegion
{
  int Adr;
  int Sz;
  const char *Name;

  int GetAdrOfs(int a) const
  {
    if (a < Adr) return -1;
    if (a >= Adr+Sz) return -1;
    return a - Adr;
  };

  BYTE GetMask(int Ofs) const;
};

const TPicMemRegion PicMemRegions[] = { 
 { 0x200000, 16, "User IDs" }, 
 { 0x300000, 10, "Configuration Words" }, 
 { 0x3F0000, 64, "Device Information Area" }, 
 { 0x3FFF00, 10, "Device Configuration Information" }, 
 { 0x3FFFFC,  2, "Revision ID" }, 
 { 0x3FFFFE,  2, "Device ID" }, 
};

const int PicMemRegionsN = sizeof(PicMemRegions) / sizeof(PicMemRegions[0]);

const int PicFlashSz = 65536;
const int PicPageSz = 128;

//const int PicFlashSz = 32768;
//const int PicPageSz = 64;


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

/*
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()     */

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog

CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMainDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMainDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
 CDialog::DoDataExchange(pDX);
 //{{AFX_DATA_MAP(CMainDlg)
 DDX_Control(pDX, IDC_RICHEDIT1, m_Edit1);
 DDX_Control(pDX, IDC_COMBO1, m_Combo1);
 //}}AFX_DATA_MAP
 DDX_Control(pDX, IDC_RICHEDIT21, m_EditLinks);
}

BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	//{{AFX_MSG_MAP(CMainDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELENDOK(IDC_COMBO1, OnSelendokCombo1)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON_SAVE, OnButtonSave)
	ON_BN_CLICKED(IDC_BUTTON_TEST, OnButtonTest)
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_USERCMD, OnButtonUsercmd)
 ON_BN_CLICKED(IDC_BUTTON8, OnButtonGenRnd) 
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_WM_DESTROY()
 ON_MESSAGE(WM_DEVICECHANGE, OnMy_WM_DEVICECHANGE) 
	ON_BN_CLICKED(IDC_BUTTON9_SetBreak, OnBUTTON9SetBreak)
	ON_BN_CLICKED(IDC_BUTTON10_ClrBreak, OnBUTTON10ClrBreak)
	ON_BN_CLICKED(IDC_BUTTON11_SetRTS, OnBUTTON11SetRTS)
	ON_BN_CLICKED(IDC_BUTTON12_ClrRTS, OnBUTTON12ClrRTS)
	ON_BN_CLICKED(IDC_BUTTON13_SetDTR, OnBUTTON13SetDTR)
	ON_BN_CLICKED(IDC_BUTTON14_ClrDTR, OnBUTTON14ClrDTR)
	ON_BN_CLICKED(IDC_BUTTON15_StartJMDProg, OnBUTTON15StartJMDProg)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	//}}AFX_MSG_MAP
 ON_WM_HELPINFO()
 ON_BN_CLICKED(IDC_BUTTON_HELP3, OnBnClickedButtonHelp3)
 ON_NOTIFY(EN_LINK, IDC_RICHEDIT21, OnLinkRichedit21)
 ON_BN_CLICKED(IDC_BUTTON15_StartJMDProg2, OnBnClickedButton15Startjmdprog2)
 ON_BN_CLICKED(IDC_BUTTON15_StartJMDProg3, OnBnClickedButton15Startjmdprog3)
 ON_BN_CLICKED(IDC_CHECK8_RdOnlyCfg, OnBnClickedCheck8Rdonlycfg)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMainDlg message handlers

/*HANDLE SetupDiGetClassDevs(CONST LPGUID ClassGuid, LPCTSTR Enumerator, 
  HWND hwndParent, DWORD Flags);
#define DIGCF_PRESENT 0x2
#define DIGCF_DEVICEINTERFACE 0x10 */


BOOL CMainDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	};

 m_EditLinks.SetBackgroundColor(FALSE, GetSysColor(COLOR_3DFACE));
 RE_LinkEnable(m_EditLinks);
 int o0s = RE_AddText(m_EditLinks, L"     Pic18f26k42 \r\n jmd -   (  RS-232)");
 int o0e = RE_AddText(m_EditLinks, L"\r\n");
 {
  m_EditLinks.SetSel(o0s, o0e);
  CHARFORMAT2A cf; cf.cbSize = sizeof(cf);
  cf.dwMask = CFM_BOLD; cf.dwEffects = CFE_BOLD;  
  m_EditLinks.SetSelectionCharFormat(cf);	 
 }; 

 RE_AddText(m_EditLinks, L"   ");
 int o1s = RE_AddText(m_EditLinks, L" ");
 int o1e = RE_AddText(m_EditLinks, L" ");
 RE_SetLinkFormat(m_EditLinks, o1s,o1e);
 RE_AddText(m_EditLinks, L" ");


 
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

 FillMemory(&m_Buffer, sizeof(m_Buffer), 0xff);
 FillMemory(&m_VerifyBuffer, sizeof(m_VerifyBuffer), 0xff);

 CopyBufferToEdit_HEX();

 m_PortSelector.SetData(m_hWnd, &m_Combo1, &m_Port);
 m_PortSelector.Process_StartProg();

 SetTimer(1, 100, NULL);

 ((CButton*)GetDlgItem(IDC_CHECK1))->SetCheck(0);
 OnCheck1();

 BOOL IsReadOnlyCfg = AfxGetApp()->GetProfileInt("CMainDlg", "IsReadOnlyCfg", FALSE);
 ((CButton*)GetDlgItem(IDC_CHECK8_RdOnlyCfg))->SetCheck(IsReadOnlyCfg);

 return TRUE;  // return TRUE  unless you set the focus to a control
};

void CMainDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		 //CAboutDlg dlgAbout;
		 //dlgAbout.DoModal();
   MessageBox("Visit to http://zvzd3d.ru/EKG", " ", MB_OK | MB_ICONINFORMATION);
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMainDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMainDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMainDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CMainDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CMainDlg::OnSelendokCombo1() 
{
  //m_PortSelect = m_Combo1.GetCurSel();	
  //AfxGetApp()->WriteProfileInt("Options", "m_PortSelect", m_PortSelect);
  //OpenPort();

  m_PortSelector.Process_OnSelEndOK();
};


void CMainDlg::OnTimer(UINT nIDEvent) 
{
  if (nIDEvent == 1021) //  
  {
     BYTE B[8];
     FOR (int i=0; i<sizeof(B); i++) B[i] = 0xcd;
     m_Port.WriteData(B, sizeof(B));
     return;
  };

  
  if (nIDEvent==1 && 10)
  {
    BYTE Buf[8192];
    int ReadedSz = 0;
    m_Port.ReadData(Buf, sizeof(Buf), ReadedSz);

    if (m_Port.IsOpened() && m_Port.IsReadError())
    {
      m_PortSelector.Process_CloseIfError();
      
      CString s = "      \n";
      s += GetSYSErrorStr(m_Port.IsReadError());
      s += "\n";
      s += "   \n";
      MessageBox(s, "    COM-", MB_OK | MB_ICONSTOP);
      return;	
    };

    
    if (ReadedSz>0)
    {
      Con<<" "<<ReadedSz<<" : ";
      int N = ReadedSz; //if (N>120) N = 120;
      for (int i=0; i<N; i++)
      {
        CString s;
        s.Format("%02x", Buf[i]);
        Con<<s;
        if (i!=N-1) Con<<", ";
      };
      if (N != ReadedSz) Con<<", ...";
      Con<<"\n";
    };

    DWORD M;
    GetCommModemStatus(m_Port.GetPortFile(), &M);

    BOOL Is_DSR_ON = M & MS_DSR_ON;
    ((CButton*)GetDlgItem(IDC_CHECK2_DSR))->SetCheck(Is_DSR_ON);
    
    //BOOL Is_CTS_ON = M & MS_CTS_ON;
    BOOL IsDataHi = GetDataIn();

    ((CButton*)GetDlgItem(IDC_CHECK3_CTS))->SetCheck(IsDataHi);
    
  };
};

void CMainDlg::OnButton1() 
{
  char Initdir[32000];
  lstrcpy(Initdir, AfxGetApp()->GetProfileString("OPEN", "PATH", "d:\\data"));

  OPENFILENAME ofn;
  ZeroMemory(&ofn,sizeof(ofn));
  ofn.lStructSize=sizeof(OPENFILENAME);
  ofn.hwndOwner=*this;
  ofn.hInstance=NULL;
  ofn.lpstrFilter="HEX -  (*.hex)\0*.hex\0  (*.*)\0*.*\0";
  ofn.lpstrCustomFilter=NULL;
  ofn.nMaxCustFilter=0;
  ofn.nFilterIndex=0;
  char newname[32000]; *newname=0;
  ofn.lpstrFile=newname;
  ofn.nMaxFile=sizeof(newname)/sizeof(*newname);
  ofn.lpstrFileTitle=NULL;
  ofn.nMaxFileTitle=0;
  ofn.lpstrInitialDir = Initdir;
  ofn.lpstrTitle="    ";
  ofn.Flags=OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
  ofn.lpstrDefExt="hex";  
  BOOL Is = ::GetOpenFileName(&ofn);  
  if (!Is) return;

  newname[ofn.nFileOffset-1] = 0;
  CString m_FilePath = newname;
  AfxGetApp()->WriteProfileString("OPEN", "PATH", m_FilePath);
  
  newname[ofn.nFileOffset-1] = '\\';

  OpenHexFile(newname);
  CopyBufferToEdit_HEX();  
};

void CMainDlg::OpenHexFile(const char *Name)
{
  Con<<" HEX -  \n";

  FillMemory(&m_Buffer, sizeof(m_Buffer), 0xff);

  FILE *pF = fopen(Name, "r");

  int RdN = 0;

  int OldAdr = -1;
  
  int BaseAdr = 0;

  while (!feof(pF))
  {
     char s[8192]; s[0] = 0;
     fgets(s, sizeof(s), pF);
     if (s[0] != ':')  continue;
     int p = 1;
     int sz = GetByte(s, p);

     BYTE Adr1 = GetByte(s, p);
     BYTE Adr0 = GetByte(s, p);
     int Adr = Adr0 + (Adr1<<8);

     BYTE type = GetByte(s, p);

     Con<<"Adr="<<(void*)Adr<<" Sz="<<sz<<" type="<<(void *)type<<"\n";

     if (type == 4 && sz == 2)
     {
       BYTE ExtAdr1 = GetByte(s, p);
       BYTE ExtAdr0 = GetByte(s, p);
       int ExtAdr = ExtAdr0 + ExtAdr1*256;
       Con.SetConsoleTextAttribute(14);
       Con<<"BASE adr = "<<(void*)ExtAdr<<"\n";
       Con.SetConsoleTextAttribute();
       BaseAdr = (ExtAdr << 16);
     };

     Adr += BaseAdr;


     if (type != 0) continue;

     if (Adr>=0x10000)
     {
        FOR (int i=0; i<sz; i++)
        { 
          const BYTE B = GetByte(s, p);            
          const int a = Adr + i;

          FOR (int reg=0; reg<PicMemRegionsN; reg++)
          {
            const TPicMemRegion &r = PicMemRegions[reg];
            int Ofs = r.GetAdrOfs(a);
            if (Ofs < 0) continue;
            m_Buffer.ExMemRegs[reg][Ofs] = B;
          };
        };
        
        Con.SetConsoleTextAttribute(11);
        Con<<"Adr = "<<(void *)Adr<<" , sz = "<<sz<<"\n";
        Con.SetConsoleTextAttribute();
        for (int i=0; i<sz; i++)
        { 
          BYTE B = GetByte(s, p);            
          Con<<(void *)B<<"  ";
        };
        Con<<"\n";
        continue;
     };

     if (Adr<0 || Adr>=65536) 
     {
       Con<<"Adr = "<<(void *)Adr<<"  , sz = "<<sz<<"\n";
       continue;
     };
     
     if (Adr<OldAdr && 0)
     {
       Con<<"Adr = "<<(void *)Adr<<"  , sz = "<<sz<<"\n";

       for (int i=0; i<sz; i++)
       { 
         BYTE B = GetByte(s, p);            
         Con<<(void *)B<<"  ";
       };
       Con<<"\n";
       continue;
     };

     OldAdr = Adr;

     for (int i=0; i<sz; i++)
     {
       if (Adr+i<0 || Adr+i>=65536) 
       {
         Con<<"Adr = "<<(void *)(Adr+i)<<"   \n";
         continue;
       };
      
       m_Buffer.Flash[Adr+i] = GetByte(s, p);            
       RdN ++;
     };
  };

  Con<<" "<<RdN<<"  \n";

  fclose(pF);
};

BYTE CMainDlg::GetByte(const char *Buf, int &Pos) const
{
   char ch1 = Buf[Pos];
   char ch2 = Buf[Pos+1];
   Pos+=2;

   ch1 = (char) CharUpper((char *)BYTE(ch1));
   ch2 = (char) CharUpper((char *)BYTE(ch2));

   if ((ch1<'0' || ch1>'9') && (ch1<'A' || ch1>'F')) return 0xff;
   if ((ch2<'0' || ch2>'9') && (ch2<'A' || ch2>'F')) return 0xff;
   
   ch1 -= '0';
   if (ch1>=10) ch1 = ch1 + '0' - 'A' + 10;
   
   ch2 -= '0';
   if (ch2>=10) ch2 = ch2 + '0' - 'A' + 10;
   
   return ch1*16 + ch2;
};

void CMainDlg::CopyBufferToEdit_HEX()
{
  ((CButton*)GetDlgItem(IDC_RADIO1))->SetCheck(1);
  ((CButton*)GetDlgItem(IDC_RADIO2))->SetCheck(0);
  CopyBufferToEdit(m_Buffer);   
};
void CMainDlg::CopyBufferToEdit_MK()
{
  ((CButton*)GetDlgItem(IDC_RADIO1))->SetCheck(0);
  ((CButton*)GetDlgItem(IDC_RADIO2))->SetCheck(1);
  CopyBufferToEdit(m_VerifyBuffer);   
};

void CMainDlg::CopyBufferToEdit(const TMKBuffer & Buffer)
{
  static char sBuf[1*1024*1024];
  char *psbuf = sBuf;

  CString Tx;
  for (int a=0; a<65536; )
  {
    CString s;
    s.Format("%04X    ", a);
    //Tx += s;
    lstrcpy(psbuf, s);  psbuf += lstrlen(s);   
    for (int i=0; i<16; i+=2)
    {
      CString s;
      s.Format("%02x%02x  ", (int)Buffer.Flash[a+1], (int)Buffer.Flash[a]);
      a+=2;
      //Tx += s;
      lstrcpy(psbuf, s);  psbuf += lstrlen(s);      
    };
    Tx="\15\12";    
    lstrcpy(psbuf, Tx);  psbuf += lstrlen(Tx);      
  };
  
  *psbuf = 0;

  m_Edit1.SetRedraw(FALSE);

  CHARFORMAT cf; ZeroMemory(&cf, sizeof(cf));
  cf.cbSize = sizeof(cf);
  cf.dwMask = CFM_COLOR | CFM_FACE | CFM_SIZE;
  cf.crTextColor = RGB(0,0,0);
  cf.yHeight = 11*20;
  lstrcpy(cf.szFaceName, "Courier New");
  m_Edit1.SetDefaultCharFormat(cf);

  m_Edit1.SetWindowText(sBuf); //Tx);

  psbuf = sBuf;

  FOR (int a=0; a<65536; )
  {
    CString s;
    s.Format("%04X    ", a);
    //Tx += s;
    lstrcpy(psbuf, s);  psbuf += lstrlen(s);    
    for (int i=0; i<16; i+=2)
    {
      CString s;
      s.Format("%02x%02x  ", (int)Buffer.Flash[a+1], (int)Buffer.Flash[a]);
      if (m_Buffer.Flash[a+1] != m_VerifyBuffer.Flash[a+1] || m_Buffer.Flash[a] != m_VerifyBuffer.Flash[a])
      {
        *psbuf = 0;
        int p1 = psbuf - sBuf; // Tx.GetLength();
        int p2 = p1+s.GetLength();
        m_Edit1.SetSel(p1, p2);
        CHARFORMAT cf; ZeroMemory(&cf, sizeof(cf));
        cf.cbSize = sizeof(cf);
        cf.dwMask = CFM_COLOR | CFM_BOLD;
        cf.dwEffects = CFE_BOLD;
        cf.crTextColor = RGB(0,0,255);
        m_Edit1.SetSelectionCharFormat(cf);
      };
      //Tx += s;      
      lstrcpy(psbuf, s);  psbuf += lstrlen(s);    
      a+=2;      
    };
    Tx="\15\12";
    lstrcpy(psbuf, Tx);  psbuf += lstrlen(Tx);
  };


  FOR (int reg=0; reg<PicMemRegionsN; reg++)
  {
    int a = PicMemRegions[reg].Adr;
    int sz = PicMemRegions[reg].Sz;
    const BYTE * pSD = Buffer.ExMemRegs[reg];
    const BYTE * pD = m_Buffer.ExMemRegs[reg];
    const BYTE * pDV = m_VerifyBuffer.ExMemRegs[reg];
    RE_AddText(m_Edit1, PicMemRegions[reg].Name);
    RE_AddText(m_Edit1, L": \r\n");
    
    char s[8192];

    sprintf(s, "%04X    ", a);
    RE_AddText(m_Edit1, s);
    
    for (int i=0; i<sz; i++)
    {
      WCHAR ss[256];
      wsprintfW(ss, L"%02x", pSD[i]);
      int is0 = RE_AddText(m_Edit1, ss);
      int ie0 = RE_AddText(m_Edit1, L"  ");
      if (pD[i] != pDV[i])
      {
        m_Edit1.SetSel(is0, ie0);
        CHARFORMAT cf; ZeroMemory(&cf, sizeof(cf));
        cf.cbSize = sizeof(cf);
        cf.dwMask = CFM_COLOR | CFM_BOLD;
        cf.dwEffects = CFE_BOLD;
        cf.crTextColor = RGB(0,0,255);
        m_Edit1.SetSelectionCharFormat(cf);
      };      
    };

    if (a == 0x3FFFFE)
    {
      const WORD Id = pSD[0] + pSD[1] * 256;
      
      const struct 
      {
        WORD MKId;
        const char *MKName;
      } MKIds[] = 
      { 0x6c60, "pic18f26k42", 
        0x6c40, "pic18f27k42",
        0x6c20, "pic18f45k42",
        0x6c00, "pic18f46k42",
        0x6be0, "pic18f47k42",
        0x6bc0, "pic18f55k42",
        0x6ba0, "pic18f56k42",
        0x6b80, "pic18f57k42",
        0x6da0, "pic18lf26k42",
        0x6d80, "pic18lf27k42",
        0x6d60, "pic18lf45k42",
        0x6d40, "pic18lf46k42",
        0x6d20, "pic18lf47k42",
        0x6d00, "pic18lf55k42",
        0x6ce0, "pic18lf56k42",
        0x6cc0, "pic18lf57k42",
    
        0x6ca0, "pic18f24k42",
        0x6c80, "pic18f25k42",
        0x6de0, "pic18lf24k42",
        0x6dc0, "pic18lf25k42", 
      };
      const int MKIdsN = sizeof(MKIds)/sizeof(MKIds[0]);
      
      int PageSz = 0;

      FOR (int i=0; i<MKIdsN; i++)
      {
        if (MKIds[i].MKId == Id)
        {
          RE_AddText(m_Edit1, " - ");
          RE_AddText(m_Edit1, MKIds[i].MKName);
          if (i>=MKIdsN-4) PageSz = 64; else PageSz = 128;
        };
      };

      if (PageSz != PicPageSz)
      {
        RE_AddText(m_Edit1, " ??!!     PicPageSz   ( PicPageSz) !!");
      };
      
    };

    RE_AddText(m_Edit1, "\r\n");

    /*
    char *ps = s;
    sprintf(ps, "%04X    ", a);
    ps += lstrlen(ps);
    for (int i=0; i<sz; i++)
    {
      sprintf(ps, "%02x  ", pD[i]);
      ps += lstrlen(ps);
    }; */

    /*if (iex == 2)
    {
      sprintf(ps, "    '");
      ps += lstrlen(ps);
      for (int i=0; i<sz; i++)
      {
        if (BYTE(pD[i])<32)
        {
          sprintf(ps, "-", pD[i]);
        }
        else
        {
          sprintf(ps, "%c", pD[i]);
        };
        ps += lstrlen(ps);
      };
      sprintf(ps, "'");
      ps += lstrlen(ps);
    }; 
    
    sprintf(ps, "\r\n");
    ps += lstrlen(ps);
    RE_AddText(m_Edit1, s); */
  };


  m_Edit1.SetRedraw(TRUE);  
  m_Edit1.InvalidateRect(NULL, TRUE);
};

void CMainDlg::Prepare()
{
  BYTE Buf[8192];
  int ReadedSz = 0;
  m_Port.ReadData(Buf, sizeof(Buf), ReadedSz);

  BYTE B[1];
  B[0] = 0xcd;
  m_Port.WriteData(B, sizeof(B));
  Sleep(10);
  m_Port.ReadData(Buf, sizeof(Buf), ReadedSz);
  B[0] = 0;
  m_Port.WriteData(B, sizeof(B));

};

bool CMainDlg::ReadVerifyBuffer()
{
  Prepare();

  for (int i=0; i<PicFlashSz; i+=32)
  {
    BYTE B[5];
    B[0] = 0xcd;
    B[1] = 0xe6;
    B[2] = i;
    B[3] = i>>8;
    B[4] = i>>16;
    m_Port.WriteData(B, sizeof(B));
  
    BYTE In[32];
    int RdSz = 0;
    m_Port.WaitData(In, sizeof(In), RdSz, 1000);
    if (RdSz != 32) 
    {
      Con<<"Err, RdSz="<<RdSz<<"\n";
      MessageBox("     !        .", "", MB_OK | MB_ICONSTOP);
      return false;
    };

    FOR (int j=0; j<32; j++) m_VerifyBuffer.Flash[i+j] = In[j];    
  };

  FOR (int reg=0; reg<PicMemRegionsN; reg++)
  {
    const TPicMemRegion & r = PicMemRegions[reg];
    const int a = r.Adr;
    
    BYTE B[5];
    B[0] = 0xcd;
    B[1] = 0xe6;
    B[2] = a;
    B[3] = a>>8;
    B[4] = a>>16;
    m_Port.WriteData(B, sizeof(B));
  
    BYTE In[32];
    int RdSz = 0;
    m_Port.WaitData(In, sizeof(In), RdSz, 1000);
    if (RdSz != 32) 
    {
      Con<<"Err, RdSz="<<RdSz<<"\n";
      MessageBox("   reg !", "", MB_OK | MB_ICONSTOP);
      return false;
    };

    int Sz = r.Sz;
    if (Sz > 32) Sz = 32;  //     ,  !!!!

    FOR (int j=0; j<Sz; j++) 
    {
      int Ofs = r.GetAdrOfs(a + j);
      if (Ofs < 0) continue;
      m_VerifyBuffer.ExMemRegs[reg][Ofs] = In[j];    
    };
  };

  return true;
};

void CMainDlg::OnButton2()   //   
{
  bool Is = ReadVerifyBuffer();
  if (!Is) return;
  CopyBufferToEdit_MK();
};

void CMainDlg::OnButtonTest()   // 
{
  bool Is = ReadVerifyBuffer();
  if (!Is) return;
  CopyBufferToEdit_HEX();

  CmdBuffersVerify();
};

void CMainDlg::CmdBuffersVerify()
{
  int ErrUserN = 0;
  int ErrNMon = 0;

  FOR (int i=0; i<PicFlashSz; i++)
  {
    if (m_Buffer.Flash[i] != m_VerifyBuffer.Flash[i]) 
    {
      if (i < 0x400) ErrNMon++; else ErrUserN++;      
    };
  };

  Con<<"ErrUserN = "<<ErrUserN<<" ErrNMon="<<ErrNMon<<"\n";

  int RegErr = 0;
  FOR (int reg=0; reg<2; reg++)
  {
    const TPicMemRegion & r = PicMemRegions[reg];    
    FOR (int i=0; i<r.Sz; i++)
    {
      if (m_Buffer.ExMemRegs[reg][i] != m_VerifyBuffer.ExMemRegs[reg][i])  RegErr++;
    };
  };

  BOOL IsErr = FALSE;
  CString sTx;
  if (ErrUserN)
  {
    IsErr = TRUE;
    sTx += "   !\r\n";
  };
  if (RegErr)
  {
    IsErr = TRUE;
    sTx += "  /   !\r\n";
  };
  if (ErrNMon)
  {
    IsErr = TRUE;
    sTx += "     ,   !\r\n";
  };

  if (sTx.GetLength() > 0)
  {
    sTx += "    ";
    MessageBox(sTx, IsErr ? " " : "", MB_OK | (IsErr ? MB_ICONSTOP : MB_ICONWARNING));
  }
  else
    MessageBox("  ,   !\n ''   ", " ", MB_OK | MB_ICONEXCLAMATION);
};

void CMainDlg::OnButtonSave() 
{
  Con<<"  \n";
  Prepare();

  int N_All = 0;
  int N_EE = 0;

  int N_EE_User = 0;

  for (int a=0; a<PicFlashSz; a+=64)
  {
    BYTE B[5+64];
    B[0] = 0xcd;
    B[1] = 0xe7;
    B[2] = a;
    B[3] = a>>8;
    B[4] = a>>16;
    FOR (int j=0; j<64; j++) B[5+j] = m_Buffer.Flash[a+j];
    m_Port.WriteData(B, sizeof(B));
    N_All++;

    BYTE In[1];
    int RdSz = 0;
    m_Port.WaitData(In, sizeof(In), RdSz, 300);
    if (RdSz != 1) 
    {
      MessageBox("  ,   !        .", " ", MB_OK | MB_ICONSTOP);
      return;
    };
    if (In[0] != 0xAA && In[0] != 0xEE)
    {
      MessageBox("   -   !         .", " ", MB_OK | MB_ICONSTOP);
      return;
    };
    if (In[0] == 0xEE) 
    {
      N_EE++;
      if (a >= 0x400) N_EE_User++;
    };
  };
  Con<<" ,   = "<<N_All<<"      = "<<N_EE<<"\n";
  if (N_EE_User)
  {
    Con.SetConsoleTextAttribute(12);
    Con<<",    "<<N_EE_User<<"     \n";
    Con.SetConsoleTextAttribute();
  };


  Con<<"  \n";
  
  OnButtonTest();
};

void CMainDlg::OnButtonStart() 
{
  Prepare();
 
  BYTE B[2];
  B[0] = 0xcd;
  B[1] = 0xeb;
  m_Port.WriteData(B, sizeof(B));

  if (0)
		for (int i=0; i<100; i++)
  {
    B[0] = 0xcd;
    m_Port.WriteData(B, 1);
    Sleep(1);
  };

		EndDialog(IDOK);
};

void CMainDlg::OnButtonUsercmd() 
{
};

void CMainDlg::OnButtonGenRnd()
{
  m_Edit1.SetWindowText("");
};



void CMainDlg::OnCheck1() 
{
  BOOL Is = ((CButton *)GetDlgItem(IDC_CHECK1))->GetCheck();
  
  if (Is)
  {
    SetTimer(1021, 1, NULL);
  }
  else
  {
    KillTimer(1021);
  }
};


BYTE CMainDlg::OutByte(BYTE b)
{
  return 0;
}

void CMainDlg::OnDestroy() 
{
	m_Port.ClosePort();
	CDialog::OnDestroy();	
}


afx_msg LRESULT CMainDlg::OnMy_WM_DEVICECHANGE(WPARAM wParam, LPARAM lParam)
{
  bool Is = m_PortSelector.Process_WM_DEVICECHANGE(wParam, lParam);
  if (Is)
  {
  };
  return 0;
};


BOOL CMainDlg::OnHelpInfo(HELPINFO* pHelpInfo)
{
  OnMyHelpInfoProcess(m_hWnd, L"DlgProgPic", pHelpInfo);
  return FALSE;
  //return CDialog::OnHelpInfo(pHelpInfo);
};


void CMainDlg::OnBnClickedButtonHelp3()
{
  OnMyHelpInfoProcess(m_hWnd, L"DlgProgPic", NULL);
};


void CMainDlg::OnLinkRichedit21(NMHDR *pNMHDR, LRESULT *pResult)
{
  ENLINK *pEnLink = reinterpret_cast<ENLINK *>(pNMHDR);
  RE_LinkClickProcess(m_hWnd, m_EditLinks, pEnLink);
  *pResult = 0;
};



void CMainDlg::OnBUTTON9SetBreak() 
{
	 SetReset(TRUE);
  Con<<"SetReset()=1 call \n";
};

void CMainDlg::OnBUTTON10ClrBreak() 
{
	 SetReset(FALSE);
  Con<<"SetReset()=0 call \n";
};

void CMainDlg::OnBUTTON11SetRTS() 
{
	 SetCLK(TRUE);
  Con<<"SetCLK()=1 call \n";
};

void CMainDlg::OnBUTTON12ClrRTS() 
{
	 SetCLK(FALSE);
  Con<<"SetCLK()=0 call \n";
}

void CMainDlg::OnBUTTON13SetDTR() 
{
	 SetData(TRUE);
  Con<<"SetData=1 call \n";
}

void CMainDlg::OnBUTTON14ClrDTR() 
{
	 SetData(FALSE);
  Con<<"SetData=0 call \n";
};


void CMainDlg::SetReset(BOOL IsHi)
{
 //    SetBreak  +12,  1      
 if (IsHi) m_Port.ClrBreak(); else m_Port.SetBreak(); 
};

void CMainDlg::SetCLK(BOOL IsHi)
{
  //  CLK    1 
  if (IsHi) m_Port.ClrRTS(); else m_Port.SetRTS(); 
};

void CMainDlg::SetData(BOOL IsHi)
{
  //    1  -
  if (IsHi) m_Port.SetDTR(); else m_Port.ClrDTR(); 
};

BOOL CMainDlg::GetDataIn()
{
  DWORD M;
  GetCommModemStatus(m_Port.GetPortFile(), &M);

  BOOL Is_CTS_ON = M & MS_CTS_ON;

  return !Is_CTS_ON;   //   1
};

void nDelay(double t)
{
 static CNikyTimer1 Tmr;
 Tmr.GetTimeAndRestart();
 while (Tmr.GetTime() < t) ;

};

void Wait()
{
  nDelay(30e-6);
};

const double TDLY = 10e-6; //   1e-6 


void CMainDlg::OutCmd8(BYTE Cmd) 
{
  FOR (int i=0; i<8; i++)
  {
    SetCLK(1);
    SetData(Cmd & 0x80); //   MSB
    Wait();

    SetCLK(0);
    Wait();

    Cmd <<= 1; 
  };

  nDelay(TDLY);
};

void CMainDlg::OutData24(DWORD Data) 
{
  Data<<=1; //     

  FOR (int i=0; i<24; i++)
  {
    SetCLK(1);
    SetData(Data & 0x800000); //   MSB
    Wait();

    SetCLK(0);
    Wait();

    Data <<= 1; 
  };

  nDelay(TDLY);
};

DWORD CMainDlg::InData24() 
{
  DWORD Data = 0;

  SetData(1);

  FOR (int i=0; i<24; i++)
  {
    SetCLK(1);
    Wait();

    Data<<=1;
    BOOL IsIn = GetDataIn();
    if (IsIn) Data |= 1;
    
    SetCLK(0);
    Wait();
  };

  nDelay(TDLY);

  return (Data>>1);
};


void CMainDlg::Prog_Load_PC_Address(DWORD Adr) 
{
  OutCmd8(0x80); // Load PC Address
  OutData24(Adr);
};

WORD CMainDlg::Prog_Read_Data_from_NVM(BOOL IsIncPC) 
{
  OutCmd8(0xFC | (IsIncPC ? 2:0)); // Read Data from NVM
  DWORD rd = InData24();
  return WORD(rd);
};

void CMainDlg::Prog_Bulk_Erase_Program_Memory()
{
  OutCmd8(0x18); // Bulk Erase Program Memory
  nDelay(25.2e-3);
  Sleep(30);
};

void CMainDlg::Prog_Load_Data_for_NVM(WORD Data, BOOL IsIncPC)
{
  OutCmd8(0x00 | (IsIncPC ? 2:0)); // Load Data for NVM
  OutData24(Data);
  nDelay(TDLY);  
};

void CMainDlg::Prog_ProgInternally()
{
  OutCmd8(0xE0); // Begin Internally Timed Programming
  const double TPINT = 6e-3; //  2.8e-3  Program memory, 5.6e-3  Configuration Words/Data EEPROM Memory
  nDelay(TPINT);
  //Sleep(10);
};

void CMainDlg::Prog_IncPCAdr()
{
  OutCmd8(0xF8); // Increment Address, PC = PC + 2
};

void CMainDlg::JMDReadAllMKBuf(TMKBuffer & Buffer)
{
 const BOOL IsReadOnlyCfg = ((CButton*)GetDlgItem(IDC_CHECK8_RdOnlyCfg))->GetCheck();

 
 FillMemory(&Buffer, sizeof(TMKBuffer), 0xff);

 SetCLK(0);
	SetData(0);
 SetReset(0);
 Sleep(200);
 SetReset(1);
 Sleep(10);

 FOR (int reg=0; reg<PicMemRegionsN; reg++)
 {
   const TPicMemRegion & r = PicMemRegions[reg];  
   Prog_Load_PC_Address(r.Adr);
   Con<<"Prog_Load_PC_Address Adr = "<<(void*)r.Adr<<"\n";

   FOR (int da=0; da<r.Sz; da+=2)
   {
     WORD data = Prog_Read_Data_from_NVM(TRUE);
     Buffer.ExMemRegs[reg][da] = BYTE(data);
     Buffer.ExMemRegs[reg][da+1] = BYTE(data>>8);
     Con<<" da="<<da<<" data="<<(void*)data<<"\n";
   };
 };

 if (!IsReadOnlyCfg)
 {
   Prog_Load_PC_Address(0);

   FOR (int a=0; a<PicFlashSz; a+=2)
   {
     if (!(a & 63))Con<<"read a = "<<(void*)a<<"\n";
     WORD data = Prog_Read_Data_from_NVM(TRUE);
     Buffer.Flash[a] = BYTE(data);
     Buffer.Flash[a+1] = BYTE(data>>8);
   };
 };

 SetReset(0);
 PurgeComm(m_Port.GetPortFile(), PURGE_RXCLEAR | PURGE_TXCLEAR);
};
 

void CMainDlg::OnBUTTON15StartJMDProg()  // StartJMD Read
{
  JMDReadAllMKBuf(m_VerifyBuffer);
  CopyBufferToEdit_MK();
};


void CMainDlg::OnBnClickedButton15Startjmdprog2() // StartJMD Prog
{
  SetCLK(0);
 	SetData(0);
  SetReset(0);
  Sleep(200);
  SetReset(1);
  Sleep(10);

  Prog_Load_PC_Address(0x300000);   //  Program Flash Memory, User ID Words, Configuration Words    Data EEPROM
  Prog_Bulk_Erase_Program_Memory();

  if (10)
  {
    FOR (int a=0; a<PicFlashSz; a+=PicPageSz)
    {
      Con<<" a = "<<(void*) a<<"\n";
      
      bool IsOnlyFF = true;
      FOR (int d=0; d<PicPageSz; d++) 
        if (m_Buffer.Flash[a+d] != 255) { IsOnlyFF = false; break; };
      
      if (IsOnlyFF) 
      {  
        continue;
      };

      Prog_Load_PC_Address(a);

      

      FOR (int d=0; d<PicPageSz; d+=2)
      {
        Prog_Load_Data_for_NVM(m_Buffer.Flash[a+d] + 256*m_Buffer.Flash[a+d+1], d<PicPageSz-2);
      };
      Prog_ProgInternally();
    };
  };

  if (10) FOR (int reg=0; reg<2; reg++)
  {
    const TPicMemRegion & r = PicMemRegions[reg];
    Prog_Load_PC_Address(r.Adr);
    FOR (int d=0; d<r.Sz; d+=2)
    {
      WORD DD = m_Buffer.ExMemRegs[reg][d] + 256*m_Buffer.ExMemRegs[reg][d+1];
      Con<<" adr="<<(void*)(r.Adr+d)<<" wr_data="<<(void*)DD<<"\n";
      Prog_Load_Data_for_NVM(DD, FALSE);
      Prog_ProgInternally();

      WORD rd = Prog_Read_Data_from_NVM(TRUE);
      if (rd != DD)
      {
        Con.SetConsoleTextAttribute(12);
        Con<<" ,  "<<(void *)rd<<" != "<<(void*)DD<<"\n";
        Con.SetConsoleTextAttribute();
      };
      
      //Prog_IncPCAdr();
    };
  };

  SetReset(0);
  PurgeComm(m_Port.GetPortFile(), PURGE_RXCLEAR | PURGE_TXCLEAR);

  Con<<"  ! \n";

  //OnBnClickedButton15Startjmdprog3();
};


void CMainDlg::OnBnClickedButton15Startjmdprog3()
{
  Con<<"    \n";
  JMDReadAllMKBuf(m_VerifyBuffer);
  Con<<"    \n";
  CopyBufferToEdit_HEX();
  CmdBuffersVerify();
};

void CMainDlg::OnRadio1() 
{
  CopyBufferToEdit_HEX();
};

void CMainDlg::OnRadio2() 
{
  CopyBufferToEdit_MK();
};


void CMainDlg::OnBnClickedCheck8Rdonlycfg()
{
  BOOL IsReadOnlyCfg = ((CButton*)GetDlgItem(IDC_CHECK8_RdOnlyCfg))->GetCheck();
  AfxGetApp()->WriteProfileInt("CMainDlg", "IsReadOnlyCfg", IsReadOnlyCfg);  
}
