#include "stdafx.h"

#ifndef WINDOWS_H
#define WINDOWS_H
#include <windows.h>
#endif

#ifndef STDIO_H
#define STDIO_H
#include <stdio.h>
#endif

#ifndef MCON2_H
#define MCON2_H
#include "mcon5.h"
#endif

static const bool OCON_IsShowCon = true;


OCON::OCON(const char *title)
{ 
  if (!OCON_IsShowCon) return;
  INIT();
  if (OCON_IsShowCon) SetConsoleTitle(title);
};

OCON::OCON()
{
  if (!OCON_IsShowCon) return;
  INIT();
};

void OCON::INIT(void)
{  
  if (!OCON_IsShowCon) return;
  
  // 2008   ---    

  BOOL IsAlloc = AllocConsole();

  hCON = GetStdHandle(STD_OUTPUT_HANDLE);  
  
  if (IsAlloc)  
  { 
    COORD c;
    c.X = 80;
    c.Y = 1024;
    SetConsoleScreenBufferSize(hCON, c);
    //Con<<"  SetConsoleScreenBufferSize \n";
  };

  //hCON=CreateConsoleScreenBuffer(GENERIC_WRITE,FILE_SHARE_WRITE,NULL,CONSOLE_TEXTMODE_BUFFER,NULL);
  //SetConsoleActiveScreenBuffer(hCON); 
};

OCON::~OCON()
{  
  if (!OCON_IsShowCon) return;
  hCON = NULL;  
};

OCON& OCON::operator<<(const char ch)
{  
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%c",ch);
   OUT_CON();
   return *this;
};
OCON& OCON::operator<<(const signed char ch)
{  
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%c",ch);
   OUT_CON();
   return *this;
};
OCON& OCON::operator<<(const unsigned char ch)
{  
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%c",ch);
   OUT_CON();
   return *this;
};


OCON& OCON::operator<<(const short int i)
{  
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%hd",i);
   OUT_CON();
   return *this;
};
OCON& OCON::operator<<(const unsigned short int i)
{  
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%hu",i);
   OUT_CON();
   return *this;
};

OCON& OCON::operator<<(const int i)
{  
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%d",i);
   OUT_CON();
   return *this;
};
OCON& OCON::operator<<(const unsigned int i)
{  
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%u",i);
   OUT_CON();
   return *this;
};


OCON& OCON::operator<<(const char *s)
{  
   if (!OCON_IsShowCon) return *this;
   lstrcpy(sCON, s);
   OUT_CON();
   return *this;
};

OCON& OCON::operator<<(const WCHAR *s)
{  
   if (!OCON_IsShowCon) return *this;
   WideCharToMultiByte(1251,0,s,-1, sCON,sizeof(sCON), NULL, NULL);
   OUT_CON();
   return *this;
};


OCON& OCON::operator<<(const double &d)
{  
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%f",d);
   OUT_CON();
   return *this;
};

OCON& OCON::operator<<(const float d)
{
  sprintf(sCON,"%f", double(d));
  OUT_CON();
  return *this;
};
       
OCON& OCON::operator<<(const void * p)
{  
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%X",(DWORD)p);
   OUT_CON();
   return *this;
};

OCON& OCON::operator<<(const unsigned long dd)
{  
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%lu",dd);
   OUT_CON();
   return *this;
};

OCON& OCON::operator<<(const signed long dd)
{  
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%ld",dd);
   OUT_CON();
   return *this;
};

OCON& OCON::operator<<(const bool b)
{  
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%hX",b);
   OUT_CON();
   return *this;
};

OCON& OCON::operator<<(const signed __int64 &i)
{  
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%I64d", i);
   OUT_CON();   
   return *this;
};

OCON& OCON::operator<<(const unsigned __int64 &i)
{
   if (!OCON_IsShowCon) return *this;
   sprintf(sCON,"%I64u", i);
   OUT_CON();   
   return *this;
};
       

void OCON::OUT_CON(void)
{  
   if (!OCON_IsShowCon) return;

   unsigned long iCON;
   int slen=lstrlen(sCON);
   CharToOemBuff(sCON,sCON,slen);
   //WriteConsole(hCON,sCON,slen,&iCON,NULL);
   WriteFile(hCON, sCON,slen,&iCON,NULL);
};

void OCON::SetConsoleTextAttributeWord(WORD atr)
{
  if (!OCON_IsShowCon) return;
  ::SetConsoleTextAttribute(hCON, atr);
};

void OCON::SetConsoleTextAttribute(BYTE color16)
{
  SetConsoleTextAttributeWord((color16 & 1 ? FOREGROUND_BLUE:0) | (color16 & 2 ? FOREGROUND_GREEN:0) | (color16 & 4 ? FOREGROUND_RED:0) | (color16 & 8 ? FOREGROUND_INTENSITY:0) | (color16 & 16 ? BACKGROUND_BLUE:0) | (color16 & 32 ? BACKGROUND_GREEN:0) | (color16 & 64 ? BACKGROUND_RED:0) | (color16 & 32 ? BACKGROUND_INTENSITY:0));
};