// OSerialPort.h: interface for the OSerialPort class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OSERIALPORT_H__890C130E_CB1B_4620_99A9_B38FE01CA578__INCLUDED_)
#define AFX_OSERIALPORT_H__890C130E_CB1B_4620_99A9_B38FE01CA578__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class OSerialPort  
{
public:
	OSerialPort();
	virtual ~OSerialPort();
 bool OpenPort(int nPort, int Speed = 115200/1);

 CString ErrStr;
 CString & GetOpenErrStr() { return ErrStr; };

 bool IsOpened() const;
 HANDLE GetPortFile() const { return m_hFile; };


 bool SetSpeed(int Speed);

 void WriteData(const BYTE *Buf, int SzBuf);
 void WriteData(const void *Buf, int SzBufByte) { WriteData((LPBYTE)Buf, SzBufByte); };

 bool ReadData(BYTE *Buf, int BufSz, int &ReadedSz);
 bool WaitData(BYTE *Buf, int BufSz, int &ReadedSz, int TimeOut);

 
 //  ,     (, USB-COM   )
 //
 DWORD IsReadError() const { return m_ErrCode; };

 void SetRTS(bool On);
 void ClosePort();


 BOOL ClearCommError(LPDWORD pComErrs, LPCOMSTAT pComStat);

 int m_Stat_ErrFrame;
 int m_Stat_Break;

 BOOL OSerialPort::ClrBreak();
 BOOL OSerialPort::SetBreak();
 BOOL OSerialPort::SetDTR();
 BOOL OSerialPort::ClrDTR();
 BOOL OSerialPort::SetRTS();
 BOOL OSerialPort::ClrRTS();


protected:
 
 HANDLE m_hFile;
 DCB m_dcb; 
 
 DWORD m_ErrCode;


 bool m_IsWaitStrategy;  // false,  ReadFile   ,  true,   - 

 COMMTIMEOUTS m_to_Read; //     ReadFile
 COMMTIMEOUTS m_to_Wait; //    ReadFile

 void SetWaitStrategy(bool IsWaitStrategy);	
};

#endif // !defined(AFX_OSERIALPORT_H__890C130E_CB1B_4620_99A9_B38FE01CA578__INCLUDED_)
