#include "stdafx.h"
#include "OSerialPortEnum.h"
#include "NikyTimer1.h"

//#define __in 
//#define __in_opt
//#define __out 
//#define __out_bcount_opt(x)
//#define __out_ecount_opt(x)
//#define __out_ecount
//#define __out_opt


#include <WinIoCtl.h>
#include <Dbt.h>
#include <SetupAPI.h>

#pragma comment(lib, "Setupapi.lib")

//#include <uuids.h>


//  VC6  SDK v7_0A   ,  uuids.lib    
//    uuisd.lib    GUID ,    

//#ifdef NikyVC6_UUIDS_H_OldLib
static const GUID MyGUID_DEVINTERFACE_COMPORT = { 0x86e0d1e0L, 0x8089, 0x11d0, 0x9c, 0xe4, 0x08, 0x00, 0x3e, 0x30, 0x1f, 0x73};
//#endif



OSerialPortEnum::OSerialPortEnum(void)
{
  m_PortsN = 0;
};


OSerialPortEnum::~OSerialPortEnum(void)
{
};

int __cdecl OSerialPortEnum::SortPortsProc(const void *pa, const void *pb) 
{
  OSerialPortEnum::TPortItem & a = *(OSerialPortEnum::TPortItem *) pa;
  OSerialPortEnum::TPortItem & b = *(OSerialPortEnum::TPortItem *) pb;
  if (a.PortNum < b.PortNum) return -1;
  if (a.PortNum > b.PortNum) return +1;
  return 0;
};




int OSerialPortEnum::EnumSerialPorts()
{
  GUID guidDeviceInterface = MyGUID_DEVINTERFACE_COMPORT;
  
  CNikyTimer1 NikyTimer;
  NikyTimer.Start();

  HDEVINFO hDI = SetupDiGetClassDevs(&guidDeviceInterface, NULL, NULL, DIGCF_PRESENT | DIGCF_DEVICEINTERFACE);
   
  if (hDI == INVALID_HANDLE_VALUE) return -1;
  
  SP_DEVINFO_DATA DeviceInfoData; //  {cbSize, ClassGuid, DevInst, Reserved};
  ZeroMemory(&DeviceInfoData, sizeof(DeviceInfoData));
  DeviceInfoData.cbSize = sizeof(SP_DEVINFO_DATA);

  BYTE * pBuf = m_Buffer;

  for (int index = 0; SetupDiEnumDeviceInfo(hDI, index, &DeviceInfoData); index++)
  {
     BOOL Is;

     char sDeviceId[256]; 
     DWORD sDeviceId_Sz = 0;
     Is = SetupDiGetDeviceInstanceId(hDI, &DeviceInfoData, sDeviceId, sizeof(sDeviceId), &sDeviceId_Sz);
     if (!Is) sDeviceId[0] = 0;
     sDeviceId[sizeof(sDeviceId)-1] = 0;
     
     DWORD PropType;

     char sPhysical_Name[256]; 
     Is = SetupDiGetDeviceRegistryProperty(hDI, &DeviceInfoData, SPDRP_PHYSICAL_DEVICE_OBJECT_NAME, &PropType, (LPBYTE)&sPhysical_Name, sizeof(sPhysical_Name), NULL);
     if (!Is) sPhysical_Name[0] = 0;
     sPhysical_Name[sizeof(sPhysical_Name)-1] = 0;

     if (!sDeviceId[0] || !sPhysical_Name[0]) continue; //    

     //lstrcpy(Item.sDeviceId, sDeviceId);
     //lstrcpy(Item.sPhysical_Name, sPhysical_Name);
     
     char sFriendly_Name[256];
     Is = SetupDiGetDeviceRegistryProperty(hDI, &DeviceInfoData, SPDRP_FRIENDLYNAME, &PropType, (LPBYTE)sFriendly_Name, sizeof(sFriendly_Name), NULL);
     if (!Is) sFriendly_Name[0] = 0;
     sFriendly_Name[sizeof(sFriendly_Name)-1] = 0;


     char sPortName[256];
     Is = SetupDiGetCustomDeviceProperty(hDI, &DeviceInfoData, "PortName", 0, 
                                         &PropType, (LPBYTE)sPortName, sizeof(sPortName), NULL);
     if (!Is) sPortName[0] = 0;
     sPortName[sizeof(sPortName)-1] = 0;

     //Con<<" find = "<<sDeviceId<<" sPortName = "<<sPortName<<"\n";
     

     int PortNum = 0;
     int n = sscanf(sPortName, "COM%d", &PortNum);
     if (n != 1 || PortNum<1)
     {
       continue; //  
     };

     //Con<<"sPortName = "<<sPortName<<" PortNum="<<PortNum<<"\n";
     
     if (m_PortsN >= sizeof(m_Ports)/sizeof(m_Ports[0])) continue;

     int Sz = sizeof(m_Buffer) - (pBuf-m_Buffer);
     if (Sz < lstrlen(sFriendly_Name)+1) continue;

     TPortItem & I = m_Ports[m_PortsN++];

     I.PortNum = PortNum;
     char * sPortFriendlyName = (char *) pBuf;
     I.sPortFriendlyName = sPortFriendlyName;
     lstrcpy(sPortFriendlyName, sFriendly_Name);
     pBuf += lstrlen(I.sPortFriendlyName) + 1;

     //Con<<"m_PortsN = "<<m_PortsN<<"\n";

     /*
     HKEY hKey = SetupDiOpenDevRegKey(hDI, &DeviceInfoData, DICS_FLAG_GLOBAL*1+DICS_FLAG_CONFIGSPECIFIC*0, 0, DIREG_DEV*1 + DIREG_DRV*0, KEY_WRITE);
     if (hKey != INVALID_HANDLE_VALUE)
     {
       Con<<"   \n";
       //m_IsKeyError = RegCreateKeyEx(HKEY_CURRENT_USER, m_BasePath, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_READ | KEY_WRITE, NULL, &m_hKey, NULL);    
       //RegOpenKeyEx
       DWORD Value = 0x123456;
       long res = RegSetValueEx(hKey, "NikyWriteToFindReg", 0, REG_DWORD, (LPBYTE)&Value, sizeof(Value));  
       Con<<"res = "<<res<<"\n";
     }
     else
     {
       Con<<"can't SetupDiOpenDevRegKey\n";
     }; */
      
     if (0)
     {
       Con<<"sDeviceId = "<<sDeviceId<<"\n";
       //Con<<"sParentId = "<<sParentId<<"\n";
       Con<<"sPhysical_Name = "<<sPhysical_Name<<"\n";       
       Con<<"sFriendly_Name = "<<sFriendly_Name<<"\n";       
       //PrintAllProps(*(DEVINST*)&DeviceInfoData.DevInst);
     };

   }; 

   SetupDiDestroyDeviceInfoList(hDI);
   
   qsort(m_Ports, m_PortsN, sizeof(m_Ports[0]), SortPortsProc);

   double T = NikyTimer.GetTime();
   Con<<" "<<m_PortsN<<" COM-,    "<<T*1000<<"  \n";
   return 0;
};

int OSerialPortEnum::SetComboBox(CComboBox & Combo, int SerialPortNumber) const
{
  int CurIndex = -1;
  
  Combo.ResetContent();
  
  int index = Combo.AddString(" ");
  Combo.SetItemData(index, 0);
  if (!SerialPortNumber) CurIndex = index;

  FOR (int i=0; i<GetPortsN(); i++)
  {
    const TPortItem & I = m_Ports[i];
    char s[8192];
    sprintf(s, "COM%d %s", I.PortNum, I.sPortFriendlyName);
    int index = Combo.AddString(s);
    Combo.SetItemData(index, I.PortNum);
    if (I.PortNum == SerialPortNumber) CurIndex = index;
  };

  if (CurIndex>=0) Combo.SetCurSel(CurIndex);
  return CurIndex;
};



OSerialPortSelector::OSerialPortSelector()
{
  m_hMain = NULL;
  m_pCombo = NULL;
  m_pPort = NULL;
  m_Number = 0;
  m_Speed = 115200;
};

OSerialPortSelector::~OSerialPortSelector()
{
};

void OSerialPortSelector::Reg_LoadPortNumber()
{
  char s[64];
  sprintf(s, "m_PortSelect_%d", m_Number);
  m_PortSelect = AfxGetApp()->GetProfileInt("OSerialPortSelector", s, 0);
};

void OSerialPortSelector::Reg_SavePortNumber()
{
  char s[64];
  sprintf(s, "m_PortSelect_%d", m_Number);
  AfxGetApp()->WriteProfileInt("OSerialPortSelector", s, m_PortSelect);
};

void OSerialPortSelector::Process_StartProg()
{
  Reg_LoadPortNumber();
  OSerialPortEnum SerialEnum;
  SerialEnum.EnumSerialPorts();
  int CurIndex = SerialEnum.SetComboBox(*m_pCombo, m_PortSelect);  
  if (CurIndex>=0) OpenPort(false); else PortNoInList();
};

void OSerialPortSelector::Process_OnSelEndOK()
{
  int index = m_pCombo->GetCurSel();
  if (index<0) return;
  m_PortSelect = m_pCombo->GetItemData(index);
  Reg_SavePortNumber();
  OpenPort(true); 
};

void OSerialPortSelector::Process_CloseIfError()
{
  ClosePortError();
};

bool OSerialPortSelector::Process_WM_DEVICECHANGE(WPARAM wParam, LPARAM lParam)
{
  if (wParam == DBT_DEVICEARRIVAL || wParam == DBT_DEVICEREMOVECOMPLETE || wParam == DBT_DEVICEREMOVEPENDING)
  {
    DEV_BROADCAST_HDR & H = * (DEV_BROADCAST_HDR *) lParam;
    if (H.dbch_devicetype == DBT_DEVTYP_PORT)
    {
      OSerialPortEnum SerialEnum;
      SerialEnum.EnumSerialPorts();
      const int CurIndex = SerialEnum.SetComboBox(*m_pCombo, m_PortSelect);
      if (CurIndex<0) 
      {
        PortNoInList(); 
        return true;
      }
      else
      {
          if (!m_pPort->IsOpened() && m_PortSelect) 
          {
            OpenPort(false); //    
            return true;
          };
      };      
    };
  };
  return false;
};




//           ( )
// m_PortSelect       ,  OpenPort()   . 
// 
void OSerialPortSelector::OpenPort(bool IsErrMsg)
{
  m_pPort->ClosePort();
  bool IsOK = !m_PortSelect || m_pPort->OpenPort(m_PortSelect, m_Speed);
  if (!IsOK)
  {
     int nPort = m_PortSelect;
     ClosePortError();
     if (IsErrMsg)
     {
       CString tit;
       tit.Format("  COM%d", nPort);
       MessageBox(m_hMain, (const char *) m_pPort->GetOpenErrStr(), tit, MB_OK | MB_ICONSTOP);
     };
     return;
  };  
  //ShowPortOpen();
};

// ,            (,    )
//          
//
void OSerialPortSelector::ClosePortError()
{
  m_pPort->ClosePort(); 
  m_PortSelect = 0;  //   ,  ,    
  m_pCombo->SetCurSel(m_PortSelect);
  //ShowPortOpen();  
};

// ,      
//     - m_PortSelect    :
//   ,       -   
//
void OSerialPortSelector::PortNoInList()
{
  m_pPort->ClosePort(); 
  //m_PortSpeedKoef = 0;
};
