#pragma once

#include "OSerialPort.h"

class OSerialPortEnum   //  -  
{
public:
 OSerialPortEnum(void);
 ~OSerialPortEnum(void);

 int EnumSerialPorts();

 struct TPortItem
 {
   int PortNum;
   const char * sPortFriendlyName;   
 };

 int GetPortsN() const { return m_PortsN; };
 const TPortItem & operator[] (int i)
 {
   if (i<0 || i>=m_PortsN) HALTY("OSerialPortEnum::TPortItem operator[] index range");
   return m_Ports[i];
 };

 //     SerialPortNumber,  
 //    " "
 //
 int SetComboBox(CComboBox & Combo, int SerialPortNumber) const;

protected:

 static int __cdecl SortPortsProc(const void *pa, const void *pb);
 
 BYTE m_Buffer[8192];

 TPortItem m_Ports[256];
 int m_PortsN;

};



class OSerialPortSelector  //         - 
{
public:

 OSerialPortSelector();
 ~OSerialPortSelector();

 void SetData(HWND hMain, CComboBox * pCombo, OSerialPort * pPort, int Number = 0)
 {
   m_hMain = hMain;
   m_pCombo = pCombo;
   m_pPort = pPort;
   m_Number = Number;
 };

 HWND m_hMain;
 CComboBox * m_pCombo;  //   
 OSerialPort * m_pPort; //  
 int m_Number; //    ,     

 int m_PortSelect;

 int m_Speed;
 
 void Reg_LoadPortNumber();
 void Reg_SavePortNumber();

 void Process_StartProg();        //        
 void Process_OnSelEndOK();       //   ,     ,  
 void Process_CloseIfError();     //      
 bool Process_WM_DEVICECHANGE(WPARAM wParam, LPARAM lParam); // ,    -  


protected:
 
 void OSerialPortSelector::OpenPort(bool IsErrMsg);
 void OSerialPortSelector::ClosePortError();
 void OSerialPortSelector::PortNoInList();
 
};

